VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.activeVB.de"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "umschalten"
      Height          =   1815
      Left            =   360
      Picture         =   "Form1.frx":0000
      Style           =   1  'Grafisch
      TabIndex        =   0
      Top             =   660
      Width           =   3975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Dieser Tipp zeigt, wie man per API die Style-Eigenschaft
' eines CommandButtons (Standart / Graphisch) zur Laufzeit
' ndern kann

' By Tobias Koch
'    TobiKochFN@T-Online.de
'    www.TKSoftware.de.ms

' Actung: zur Entwicklungszeit muss die Style Eigenschaft des
' Buttons auf vbButtonGraphical (=1) stehen!

Option Explicit

'Deklaration: API-Funktionen
Private Declare Function GetWindowLong Lib "user32" Alias _
    "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) _
    As Long
    
Private Declare Function SetWindowLong Lib "user32" Alias _
    "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long

'Deklaration: API-Konstanten
Private Const GWL_STYLE As Long = -16
Private Const BS_OWNERDRAW As Long = &HB
Private Const BS_MULTILINE As Long = &H2000

Private blnIsNormalStyle As Boolean

Private Sub Command1_Click()
    ' Achtung: Der Stil des Buttons wird intern zwar gendert,
    ' die Eigenschaft "Style" jedoch nicht!
    ' aus diesem Grund kommt die Variable blnIsNormalStyle zum Einsatz
    If blnIsNormalStyle Then
        ChangeStyle Command1, True
    Else
        ChangeStyle Command1, False
    End If
End Sub

Public Function ChangeStyle(ByVal Button As CommandButton, _
    ByVal Flag As Boolean)
'   ChangeStyle:
'   ndert die Style-Eigenschaft eines Buttons zur Laufzeit
'   Button: CommandButton, dessen Stil gendert werden soll
'   Flag: True ->  Graphischen Button erstellen
'         False -> Normalen Buton erstellen
    Dim lngOldStyle As Long
    
    ' Aktuelle Fensterstile auslesen
    lngOldStyle = GetWindowLong(Button.hwnd, GWL_STYLE)
    
    ' Stil ndern
    If Flag Then
    
        ' Graphischer Button
        lngOldStyle = lngOldStyle Or BS_OWNERDRAW And Not BS_MULTILINE
        blnIsNormalStyle = False
    Else
    
         'Normaler Button
        lngOldStyle = lngOldStyle And Not BS_OWNERDRAW Or BS_MULTILINE
        blnIsNormalStyle = True
    End If
    
    ' Neue Stile setzen
    SetWindowLong Button.hwnd, GWL_STYLE, lngOldStyle
    Button.Refresh
End Function


